import java.util.Set;
import java.util.HashSet;
import java.util.Map;
import java.util.TreeMap;
import java.util.Set;
import java.util.HashSet;
import java.util.TreeSet;
import java.util.List;
import java.util.ArrayList;
import java.util.Comparator;
/*******************************************************************************
 * Třída {@code CollectionDemo} je hlavní třídou projektu,
 * vstupním bodech 
 *
 * @author  Tomáš Pitner
 * @version 1.00.0000 — 2019-10-29
 */
public class CollectionDemo
{
    private static Comparator<Person> fc = new FirstnameComparator();
    /***************************************************************************
     * Metoda, prostřednictvím níž se spouští celá aplikace.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
       demoMap();
       //demoList();
    }
    
    public static void demoSet() {
       Set<Person> people = new TreeSet<>();
       people.add(new Person("Jan", "Novák"));// Set does not store duplicates
       people.add(new Person("Karel", "Novák"));// but only if equals AND hashCode
       people.add(new Person("Jan", "Novák"));// are defined properly!
       people.add(new Person("Libor", "Horák"));
       people.add(new Person("Adam", "Kučera"));
       
       Set<Person> people2 = new TreeSet<>(fc);
       people2.addAll(people);
       
       System.out.println("Natural ordering " + people);
       System.out.println("Firstname ordering " + people2);
    }
    
    public static void demoMap() {
       Map<Person, Double> people = new TreeMap<>();
       people.put(new Person("Jan", "Novák"), 10000.0);// Set does not store duplicates
       System.out.println("Jan Novák stored");
       
       people.put(new Person("Karel", "Novák"), 8000.0);// but only if equals AND hashCode
       System.out.println("Karel Novák stored");
       
       try {
           people.put(new Person(null, "Novák"), 100000.0);// are defined properly!
           System.out.println("Second Jan Novák stored");
       } catch(NullPointerException npe) {
           System.out.println("Second Jan Novák has not been stored");
       }
       
       people.put(new Person("Libor", "Horák"), 20000.0);
       System.out.println("Libor Horák stored");
       
       people.put(new Person("Adam", "Kučera"), 15000.0);
       System.out.println("Adam Kučera stored");
       
       System.out.println("Natural ordering " + people);
    }
    
    public static void demoList() {
       List<Person> people = new ArrayList<>();
       
       
       System.out.println(people);
    }
}

