import java.util.Comparator;

public class FirstnameComparator implements Comparator<Person> {
    
    private boolean desc = false;
    
    public FirstnameComparator() {
        this(false);
    }
    
    public FirstnameComparator(boolean desc) {
        this.desc = desc;
    }
    
    @Override
    public int compare(Person p, Person q) {
        if(p == null || q == null) throw new NullPointerException("Cannot compare null");
        
        int c = p.getFirstname().compareTo(q.getFirstname());
        if(c != 0) return desc ? -c : c;
        
        c = p.getSurname().compareTo(q.getSurname());
        return desc ? -c : c;
    }
}
